package hello.jsp;
 
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

/**
 * Simple redirection.
 * $Revision: 1.3 $ $Date: 2002/10/06 14:24:59 $ (helder@acm.org).
 */
public class DefaultCommand implements Command {
    
    private String successUrl;
    private String failureUrl;
    
    public DefaultCommand(String successUrl, String failureUrl) {
        this.successUrl = successUrl;
        this.failureUrl = failureUrl;
    }
    
    public Object execute(HttpServletRequest request, HttpServletResponse response, MessageBeanDAO dao) throws CommandException {
        return successUrl;
    }

    /**
     * Object.toString() implementation.
     */
    public String toString() {
        return this.getClass().getName() + "(\"" + successUrl + "\", \"" + failureUrl + "\")";
    }
    
    /**
     * Object.equals() implementation.
     */
    public boolean equals(Object obj) {
        if ( !(obj instanceof DefaultCommand) ) return false;
        DefaultCommand cmd = (DefaultCommand) obj;
        return successUrl.equals(cmd.successUrl) && failureUrl.equals(cmd.failureUrl);
    }
    
    /**
     * Object.hashCode() implementation.
     */
    public int hashCode() {
        return 37 * successUrl.hashCode() * failureUrl.hashCode();
    }
}
