package hello.jsp;

/**
 * This Data Access Object interface separates the action commands from the data layer,
 * allowing for different persistence mechanisms, such as XML binding or different
 * relational database persistence methods (JDO, JDBC drivers, etc.)
 * $Revision: 1.2 $ $Date: 2002/10/06 22:52:41 $ (helder@acm.org).
 */ 
public interface MessageBeanDAO {
    
    /**
     * Returns data storage location (data source, directory, uri).
     */
    public Object getLocator();
    
    /**
     * Saves message bean data in persistent media.
     */
    public void persist(MessageBean messageBean) throws PersistenceException;
    
    /**
     * Retrieves messageBean from persistent media given an identification key.
     */
    public MessageBean retrieve(int key) throws PersistenceException;
    
    /**
     * Retrieves all messages stored.
     */
    public MessageBean[] retrieveAll() throws PersistenceException;
    
    /**
     * Retrieves last messageBean that was saved.
     */
    public MessageBean retrieveLast() throws PersistenceException;
}
