package hello.jsp;

import javax.servlet.*; 
import javax.servlet.http.*;
import java.io.*;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * Tests the results of NewMessageCommand.
 * Testing for JAXB implementation of DAO (refactor so tests can apply to any version).
 * $Revision: 1.3 $ $Date: 2002/10/06 14:24:59 $ (helder@acm.org).
 */
public class NewMessageCommandTest extends ServletTestCase {
    
    public NewMessageCommandTest(String name) {
        super(name);
    }
    public static Test suite() {
        return new TestSuite(NewMessageCommandTest.class);
    }

    private NewMessageCommand command;
    private MessageBeanDAO dao;
    private String testMessage = "This is a test message";
    
    public void beginExecute(WebRequest clientRequest) {
        clientRequest.addParameter("message", testMessage);
    }
    
    public void setUp() throws IOException {
        File testDir = new File("/tmp/test");
        testDir.mkdir();
        dao = new XMLMessageBeanDAO("/tmp/test");
        command = new NewMessageCommand("/messages.jsp", "/index.html");
    }
    
    public void testExecute() throws CommandException {
        Object obj = command.execute(request, response, dao); // if return type is not String, exception will occur
        
        // message.count should exist
        File countFile = new File("/tmp/test/message.count");
        assertTrue("Count file does not exist!", countFile.exists());
        
        // lastMessage attribute in request should exist with messageBean which contains message
        Object attribute = request.getAttribute("messageBean");
        assertNotNull("No attribute messageBean exists in Session.", attribute);
        MessageBean bean = (MessageBean)attribute;
        String result = bean.getMessage();
        assertEquals("Message received does not match message sent.", testMessage, result);
        
        // returned object should contain success argument
        String returned = (String) obj;
        assertEquals("Value returned is incorrect.", "/messages.jsp", returned);
    }
    
}
