package hello.taglib;

import javax.servlet.*; 
import javax.servlet.jsp.*; // JspWriter, JspException, JspTagException
import javax.servlet.jsp.tagext.*; // TagSupport, Tag

import hello.jsp.MessageBean;

import org.apache.cactus.*;
import junit.framework.*;

/**
 * $Revision: 1.2 $ $Date: 2002/09/28 20:27:28 $ (helder@acm.org).
 */
public class PrintFieldTagTest extends JspTestCase {
    
    public PrintFieldTagTest(String name) {
        super(name);
    }
    public static Test suite() {
        return new TestSuite(PrintFieldTagTest.class);
    }
    
    private PrintFieldTag tag;
    private MessageBean testBean;
    private BodyContent tempOut;
    
    public void setUp() throws JspException {
        // Test MessageBean
        testBean = new MessageBean();
        testBean.setMessage("This is a Cactus Test Message");
        testBean.setTime("12/12/2002 13:45");
        testBean.setHost("somehost");
        
        // parent tag
        PrintMessagesTag parent = new PrintMessagesTag();
        parent.setPageContext(this.pageContext);
        this.pageContext.getRequest().setAttribute("messages", new MessageBean[]{testBean});
        parent.setArray("messages");
        parent.doStartTag();
        
        // this tag
        tag = new PrintFieldTag();
        tag.setPageContext(this.pageContext);
        tag.setParent(parent);
        
        tag.setProperty("message");
        
        tempOut = this.pageContext.pushBody();
    }
    
    public void testDoStartTag() throws JspException {
        tag.setPrefix("<message>");
        tag.setSuffix("</message>");
        int result = tag.doStartTag();
        assertEquals(tag.SKIP_BODY, result);
        String output = tempOut.getString();
        assertEquals("<message>This is a Cactus Test Message</message>".trim(), output.trim());
        pageContext.popBody();
    }
    
}
