package hello.taglib;
 
import javax.servlet.*;
import javax.servlet.jsp.*; // JspWriter, JspException, JspTagException
import java.lang.reflect.*; // Method
import java.beans.*; // BeanInfo, Introspector, PropertyDescriptor

import hello.jsp.MessageBean;

import junit.framework.*;

/**
 * $Revision: 1.2 $ $Date: 2002/09/28 20:27:27 $ (helder@acm.org).
 */
public class TagUtilsTest extends TestCase {
    
    public TagUtilsTest(String name) {
        super(name);
    }
    public static Test suite() {
        return new TestSuite(TagUtilsTest.class);
    }
    
    private MessageBean testBean;
    
    public void setUp() {
        testBean = new MessageBean();
        testBean.setMessage("This is a Cactus Test Message");
        testBean.setTime("12/12/2002 13:45");
        testBean.setHost("somehost");
    }
    
    public void testGetPropertyValue() throws JspTagException {
        String message = TagUtils.getPropertyValue(testBean, "message");
        assertNotNull("'message' property is null.", message);
        assertEquals("This is a Cactus Test Message", message);
        
        String time = TagUtils.getPropertyValue(testBean, "time");
        assertNotNull("'time' property is null.", time);
        assertEquals("12/12/2002 13:45", time);
        
        String host = TagUtils.getPropertyValue(testBean, "host");
        assertNotNull("'host' property is null.", host);
        assertEquals("somehost", host);
    }

}
